// <auto-generated>
//  automatically generated by the FlatBuffers compiler, do not modify
// </auto-generated>

namespace Veneris.Communications
{

using global::System;
using global::System.Collections.Generic;
using global::FlatBuffers;

public struct CreateVehicle : IFlatbufferObject
{
  private Table __p;
  public ByteBuffer ByteBuffer { get { return __p.bb; } }
  public static void ValidateVersion() { FlatBufferConstants.FLATBUFFERS_2_0_0(); }
  public static CreateVehicle GetRootAsCreateVehicle(ByteBuffer _bb) { return GetRootAsCreateVehicle(_bb, new CreateVehicle()); }
  public static CreateVehicle GetRootAsCreateVehicle(ByteBuffer _bb, CreateVehicle obj) { return (obj.__assign(_bb.GetInt(_bb.Position) + _bb.Position, _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __p = new Table(_i, _bb); }
  public CreateVehicle __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public uint Id { get { int o = __p.__offset(4); return o != 0 ? __p.bb.GetUint(o + __p.bb_pos) : (uint)0; } }
  public Veneris.Communications.Vec3? Position { get { int o = __p.__offset(6); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public Veneris.Communications.Vec3? Polarization { get { int o = __p.__offset(8); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public float Radius { get { int o = __p.__offset(10); return o != 0 ? __p.bb.GetFloat(o + __p.bb_pos) : (float)0.0f; } }

  public static void StartCreateVehicle(FlatBufferBuilder builder) { builder.StartTable(4); }
  public static void AddId(FlatBufferBuilder builder, uint id) { builder.AddUint(0, id, 0); }
  public static void AddPosition(FlatBufferBuilder builder, Offset<Veneris.Communications.Vec3> positionOffset) { builder.AddStruct(1, positionOffset.Value, 0); }
  public static void AddPolarization(FlatBufferBuilder builder, Offset<Veneris.Communications.Vec3> polarizationOffset) { builder.AddStruct(2, polarizationOffset.Value, 0); }
  public static void AddRadius(FlatBufferBuilder builder, float radius) { builder.AddFloat(3, radius, 0.0f); }
  public static Offset<Veneris.Communications.CreateVehicle> EndCreateVehicle(FlatBufferBuilder builder) {
    int o = builder.EndTable();
    return new Offset<Veneris.Communications.CreateVehicle>(o);
  }
  public static void FinishCreateVehicleBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.CreateVehicle> offset) { builder.Finish(offset.Value); }
  public static void FinishSizePrefixedCreateVehicleBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.CreateVehicle> offset) { builder.FinishSizePrefixed(offset.Value); }
};


}
